/*
 * s_cellio.c
 *
 *	Ver 0.1:	2016/07/01
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "s_csvio.h"
#include "s_cellio.h"

/*
 *
 */

#define	EOS	'\0'

/*
 *
 */

Cell_Position *cell_name_decode ( Cell_Position *pp, char *cn ) {
  int x = 0;
  int y = 0;
  int ac = 0;
  int ch;

  while ( ( ch = *cn++ ) != EOS ) {
	if ( isalpha ( ch ) ) {
	  /* str = 'a' 〜 'z' -> ch - 'a' */
	  x = x * ( 'z' - 'a' + 1 ) + ( tolower ( ch ) - 'a' );
	  ac = ac * ( 'z' - 'a' + 1 ) + 1;
	} else if ( isdigit ( ch ) ) {
	  y = y * ( '9' - '0' + 1 ) + ( ch - '0' );
	}
  }

  y = y - 1;
  x = x + ac - 1;		/* A1 -> (0,0) */

  //  printf ( "decode : x = %d, y = %d\n", x, y );

  if ( s_in_sheet(x,y) ) {
	pp -> x = x;
	pp -> y = y;
	return pp;
  }

  return NULL;
}

/*
 *
 */

int	set_x ( char *cp, int x, int pos ) {
  int len;
  int h = x / ( 'z' - 'a' + 1 );
  int l = x % ( 'z' - 'a' + 1 );

  //  printf ( "x = %d, h = %d, l = %d, pos = %d\n", x, h, l, pos );

  if ( h == 0 ) {
	len = pos;
  } else {
	len = set_x ( cp, h - 1, pos + 1 );
  }

  cp[len-pos] = l + 'A';

  return len;
}

char *cell_name_encode ( char *cn, Cell_Position *pp ) {
  int len = set_x ( cn, pp -> x, 0 );

  sprintf ( cn + len + 1, "%d", pp -> y + 1 );

  return cn;
}

/*
 *
 */

static void s_error ( char *pos, char *errmsg ) {

  fprintf ( stderr, "Error(s_cellio:%s) : %s\n", pos, errmsg );
  exit ( -1 );
}

/*
 *
 */

int s_get_cell_with_name ( char *cn ) {
	Cell_Position p;

	if ( cell_name_decode ( &p, cn ) == NULL ) {
	  s_error ( "s_get_cell_with_name", "Illigal cell name" );
	}

	return s_get_cell_with_position ( p.x, p.y );
}

void s_set_cell_with_name ( char *cn, int value ) {
	Cell_Position p;

	if ( cell_name_decode ( &p, cn ) == NULL ) {
	  s_error ( "s_get_cell_with_name", "Illigal cell name" );
	}

	s_set_cell_with_position ( p.x, p.y, value );
}

/*
 *
 */

