/*
 * s_csvio.c
 *
 */

#include <stdio.h>
#include "s_csvio.h"

/*
 *
 */

static	int	sheet[S_SHEET_X][S_SHEET_Y];
static	int mx = 0;
static	int my = 0;

/*
 *
 */

static	void init_sheet() {
	int y;

	for ( y = 0; y < S_SHEET_Y; y++ ) {
		int x;

		for ( x = 0; x < S_SHEET_X; x++ ) {
			sheet[x][y] = 0;
		}
	}

	mx = 0;
	my = 0;
}

/*
 *
 */

static	void	read_sheet ( FILE *fp ) {
	int ch;
	int v = 0;
	int s = 1;
	int x = 0;
	int y = 0;

	init_sheet();

	while ( ( ch = fgetc( fp ) ) != EOF ) {
		if ( ch == '\n' ) {
			sheet[x][y] = s * v;
			s = 1;
			v = 0;
			if ( mx < x + 1 ) {
				mx = x + 1;
			}
			x = 0;
			y++;
		} else if ( ch == ',' ) {
			sheet[x][y] = s * v;
			s = 1;
			v = 0;
			x++;
		} else if ( ch == '-' ) {
			s = -1;
		} else if ( isdigit ( ch ) ) {
			v = v * 10 + ( ch - '0' );
		} else {
			//
		}
	}

	my = y;
}

/*
 *
 */

int s_load_csv ( char *file ) {
	FILE *fp;

	if ( file != NULL ) {
		if ( ( fp = fopen ( file, "r" ) ) != NULL ) {
			read_sheet ( fp );
			fclose ( fp );
			return 0;
		}
		file = NULL;
	}

	return 1;
}

/*
 *
 */

static	void	write_sheet ( FILE *fp ) {
	int y;

	for ( y = 0; y < my; y++ ) {
		int x;

		for ( x = 0; x < mx; x++ ) {
			fprintf ( fp, "%d", sheet[x][y] );
			if ( x < mx - 1 ) {
				fprintf ( fp, ",\t" );
			} else {
				fprintf ( fp, "\n" );
			}
		}
	}

}

/*
 *
 */

int	s_save_csv ( char *file ) {
	FILE *fp;

	if ( file != NULL ) {
		if ( ( fp = fopen ( file, "w" ) ) != NULL ) {
			write_sheet ( fp );
			fclose ( fp );
			return 0;
		}
	}

	return -1;
}

/*
 *
 */

int s_get_cell_with_position ( int px, int py ) {

	return sheet[px][py];
}

void s_set_cell_with_position ( int px, int py, int value ) {

	sheet[px][py] = value;

	if ( px + 1 > mx ) {
		mx = px + 1;
	}

	if ( py + 1 > my ) {
		my = py + 1;
	}
}

/*
 *
 */

void dump() {

	int y;

	printf ( "mx = %d, my = %d\n", mx, my );

	for ( y = 0; y < my; y++ ) {
		int x;

		for ( x = 0; x < mx; x++ ) {
			printf ( "%d\t", sheet[x][y] );
		}
		printf ( "\n" );
	}

}

/*
 *
 */
