/*
 * tcell.c
 */

#include <stdio.h>
#include <stdlib.h>
#include "s_csvio.h"
#include "s_cellio.h"

/*
 *
 */

static void printp ( Cell_Position *p ) {
	char cn[10];

	cell_name_encode ( cn, p );
	printf ( "x = %d, y = %d, cn = %s\n", p -> x, p -> y, cn );

}

static void pdecode ( char *cn ) {
	Cell_Position p;

	cell_name_decode ( &p, cn );

	printf ( "%s : ", cn );
	printp ( &p );
}


static void tdecode ( ) {

	pdecode ( "a1" );
	pdecode ( "a2" );
	pdecode ( "a9" );
	pdecode ( "a10" );
	pdecode ( "a11" );
	pdecode ( "a21" );

	pdecode ( "b1" );
	pdecode ( "c1" );
	pdecode ( "d1" );
	pdecode ( "z1" );
	pdecode ( "aa1" );
	pdecode ( "ab1" );
	pdecode ( "az1" );
	pdecode ( "ba1" );
	pdecode ( "bz1" );
	pdecode ( "za1" );
	pdecode ( "zz123" );
	pdecode ( "aaa123" );

}

/*
 *
 */

void pget( char *cn ) {

  printf ( "%s : %d\n", cn, s_get_cell_with_name ( cn ) );

}

void tget() {

  pget ( "A1" );
  pget ( "A2" );
  pget ( "B1" );
  pget ( "B2" );

  pget ( "A9" );
  pget ( "J1" );
  pget ( "J9" );

}

/*
 *
 */

void tset() {

  s_set_cell_with_name ( "A1", 99 );
  s_set_cell_with_name ( "A9", -9 );
  s_set_cell_with_name ( "J1", -9 );
  s_set_cell_with_name ( "J9", -99 );

}

/*
 *
 */

void tcell() {
	tdecode();
	tget();
	tset();
}

/*
 *
 */

int main ( int argc, char *argv[] ) {

  if ( argc > 1 ) {
	s_load_csv ( argv[1] );

	tcell();

	if ( argc > 2 ) {
		s_save_csv ( argv[2] );
	} else {
		s_save_csv ( argv[1] );
	}
  }

  return 0;
}
